// Copyright (c) 1995, 1996 Regents of the University of California.
// All rights reserved.
//
// This software was developed by the Arcadia project
// at the University of California, Irvine.
//
// Redistribution and use in source and binary forms are permitted
// provided that the above copyright notice and this paragraph are
// duplicated in all such forms and that any documentation,
// advertising materials, and other materials related to such
// distribution and use acknowledge that the software was developed
// by the University of California, Irvine.  The name of the
// University may not be used to endorse or promote products derived
// from this software without specific prior written permission.
// THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
// WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.

// File: BasicApplication.java
// Class: BasicApplication
// original author: jrobbins@ics.uci.edu
// $Id: BasicApplication.java,v 1.7 1997/01/24 19:22:51 jrobbins Exp $

//package uci.graphedit.mydemo;

import java.awt.*;
import java.util.*;
import java.lang.*;
import uci.graphedit.*;

class myEditorFrame extends EditorFrame 
{
   myEditorFrame(NetList n)
   { super(n);
     System.out.println(" myEditorFrame is created ");
   }

   public boolean handleEvent(Event e)
   { 
      //System.out.println(" in handleEvent() of myEditorFrame ");
      if(e.id == Event.WINDOW_DESTROY)
      {   System.out.println("Event.WINDOW_DESTROY is received ");
          editor().executeAction(new ActionQuit(),e);
          return true;
      }
      return super.handleEvent(e); 
   }

}

class gefFrame extends Frame
{
   private Editor myEditor = null;

   gefFrame(Editor _myEditor)
   { myEditor = _myEditor; }

   public boolean
   handleEvent(Event e)
   {  
     boolean ret = false;
      
     if(e.id == Event.WINDOW_DESTROY && myEditor != null )
     {
        System.out.println(" Event.WINDOW_DESTROY is being received !");
        myEditor.executeAction(new ActionQuit(),e);
        ret = true;

     }// end of if

     return ret;

   }// end of handleEvent()

}// end of class gefFrame

/** A simple example of the minimum code needed to build an
 * application using GEF. */

public class BasicApplication {

  ////////////////////////////////////////////////////////////////
  // Instance Variables
  
  //private EditorFrame _edFrame;
  private myEditorFrame _edFrame;

  private gefFrame _palFrame;
  private PaletteTop _pal;

  private ControlPanel control;
  private gefFrame     _cntFrame;

  ////////////////////////////////////////////////////////////////
  // Constructors
  
  public BasicApplication() {
    //_edFrame = new EditorFrame(new NetList());
    _edFrame = new myEditorFrame(new NetList());
    _edFrame.setTitle("BasicApplication Editor");
    _edFrame.move(10, 10);
    _edFrame.show();

    _palFrame = new gefFrame(_edFrame.editor());
    _pal = new PaletteTop(new PaletteFig());

    _pal.frame(_palFrame);
    _pal.definePanel();
    _palFrame.setLayout(new BorderLayout());
    _palFrame.add("Center", _pal);
    _palFrame.pack();
    _palFrame.setTitle("Palette");
    _palFrame.move(500, 10);
    _palFrame.show();

    
    _cntFrame = new gefFrame(_edFrame.editor());
    control = new ControlPanel(_edFrame.editor());

    _cntFrame.setTitle("Control");
    _cntFrame.setLayout( new BorderLayout() );
    _cntFrame.add("Center", control);
    _cntFrame.pack();
    _cntFrame.move(100,500);
    _cntFrame.show();

  }

  ////////////////////////////////////////////////////////////////
  // Main
  
  public static void main(String args[]) {
    BasicApplication demo = new BasicApplication();
  }

} /* end class BasicApplication */

